"""
    SORACOM API

    SORACOM API v1  # noqa: E501

    The version of the OpenAPI document: VERSION_PLACEHOLDER
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from soracom_api.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from soracom_api.exceptions import ApiAttributeError



class ActionConfigProperty(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('execution_date_time_const',): {
            'IMMEDIATELY': "IMMEDIATELY",
            'BEGINNING_OF_NEXT_MONTH': "BEGINNING_OF_NEXT_MONTH",
            'BEGINNING_OF_NEXT_DAY': "BEGINNING_OF_NEXT_DAY",
            'AFTER_ONE_DAY': "AFTER_ONE_DAY",
            'NEVER': "NEVER",
        },
        ('http_method',): {
            'GET': "GET",
            'POST': "POST",
            'PUT': "PUT",
            'DELETE': "DELETE",
        },
        ('speed_class',): {
            'MINIMUM': "s1.minimum",
            'SLOW': "s1.slow",
            'STANDARD': "s1.standard",
            'FAST': "s1.fast",
            '4XFAST': "s1.4xfast",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'execution_date_time_const': (str,),  # noqa: E501
            'access_key': (str,),  # noqa: E501
            'body': (str,),  # noqa: E501
            'content_type': (str,),  # noqa: E501
            'endpoint': (str,),  # noqa: E501
            'execution_offset_minutes': (str,),  # noqa: E501
            'function_name': (str,),  # noqa: E501
            'headers': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'http_method': (str,),  # noqa: E501
            'message': (str,),  # noqa: E501
            'parameter1': (str,),  # noqa: E501
            'parameter2': (str,),  # noqa: E501
            'parameter3': (str,),  # noqa: E501
            'parameter4': (str,),  # noqa: E501
            'parameter5': (str,),  # noqa: E501
            'secret_access_key': (str,),  # noqa: E501
            'speed_class': (str,),  # noqa: E501
            'title': (str,),  # noqa: E501
            'to': (str,),  # noqa: E501
            'url': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'execution_date_time_const': 'executionDateTimeConst',  # noqa: E501
        'access_key': 'accessKey',  # noqa: E501
        'body': 'body',  # noqa: E501
        'content_type': 'contentType',  # noqa: E501
        'endpoint': 'endpoint',  # noqa: E501
        'execution_offset_minutes': 'executionOffsetMinutes',  # noqa: E501
        'function_name': 'functionName',  # noqa: E501
        'headers': 'headers',  # noqa: E501
        'http_method': 'httpMethod',  # noqa: E501
        'message': 'message',  # noqa: E501
        'parameter1': 'parameter1',  # noqa: E501
        'parameter2': 'parameter2',  # noqa: E501
        'parameter3': 'parameter3',  # noqa: E501
        'parameter4': 'parameter4',  # noqa: E501
        'parameter5': 'parameter5',  # noqa: E501
        'secret_access_key': 'secretAccessKey',  # noqa: E501
        'speed_class': 'speedClass',  # noqa: E501
        'title': 'title',  # noqa: E501
        'to': 'to',  # noqa: E501
        'url': 'url',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, execution_date_time_const, *args, **kwargs):  # noqa: E501
        """ActionConfigProperty - a model defined in OpenAPI

        Args:
            execution_date_time_const (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            access_key (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            body (str): Only for ExecuteWebRequestAction (Optional). [optional]  # noqa: E501
            content_type (str): Only for ExecuteWebRequestAction. [optional]  # noqa: E501
            endpoint (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            execution_offset_minutes (str): Run in the minutes after the timing of executionDateTimeConst. [optional]  # noqa: E501
            function_name (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            headers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Only for ExecuteWebRequestAction (Optional). [optional]  # noqa: E501
            http_method (str): Only for ExecuteWebRequestAction. [optional]  # noqa: E501
            message (str): Only for SendMailAction, SendMailToOperatorAction. [optional]  # noqa: E501
            parameter1 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter2 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter3 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter4 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter5 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            secret_access_key (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            speed_class (str): Only for ChangeSpeedClassAction. [optional]  # noqa: E501
            title (str): Only for SendMailAction, SendMailToOperatorAction. [optional]  # noqa: E501
            to (str): Only for SendMailAction. [optional]  # noqa: E501
            url (str): Access URL and parameters. Only for ExecuteWebRequestAction. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.execution_date_time_const = execution_date_time_const
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, execution_date_time_const, *args, **kwargs):  # noqa: E501
        """ActionConfigProperty - a model defined in OpenAPI

        Args:
            execution_date_time_const (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            access_key (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            body (str): Only for ExecuteWebRequestAction (Optional). [optional]  # noqa: E501
            content_type (str): Only for ExecuteWebRequestAction. [optional]  # noqa: E501
            endpoint (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            execution_offset_minutes (str): Run in the minutes after the timing of executionDateTimeConst. [optional]  # noqa: E501
            function_name (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            headers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Only for ExecuteWebRequestAction (Optional). [optional]  # noqa: E501
            http_method (str): Only for ExecuteWebRequestAction. [optional]  # noqa: E501
            message (str): Only for SendMailAction, SendMailToOperatorAction. [optional]  # noqa: E501
            parameter1 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter2 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter3 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter4 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            parameter5 (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            secret_access_key (str): Only for InvokeAWSLambdaAction. [optional]  # noqa: E501
            speed_class (str): Only for ChangeSpeedClassAction. [optional]  # noqa: E501
            title (str): Only for SendMailAction, SendMailToOperatorAction. [optional]  # noqa: E501
            to (str): Only for SendMailAction. [optional]  # noqa: E501
            url (str): Access URL and parameters. Only for ExecuteWebRequestAction. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.execution_date_time_const = execution_date_time_const
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
