"""
    SORACOM API

    SORACOM API v1  # noqa: E501

    The version of the OpenAPI document: VERSION_PLACEHOLDER
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from soracom_api.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from soracom_api.exceptions import ApiAttributeError


def lazy_import():
    from soracom_api.model.arc_session_status import ArcSessionStatus
    from soracom_api.model.capabilities import Capabilities
    from soracom_api.model.imei_lock import ImeiLock
    from soracom_api.model.previous_session_status import PreviousSessionStatus
    from soracom_api.model.session_status import SessionStatus
    from soracom_api.model.sim_profile import SimProfile
    from soracom_api.model.tag_set import TagSet
    globals()['ArcSessionStatus'] = ArcSessionStatus
    globals()['Capabilities'] = Capabilities
    globals()['ImeiLock'] = ImeiLock
    globals()['PreviousSessionStatus'] = PreviousSessionStatus
    globals()['SessionStatus'] = SessionStatus
    globals()['SimProfile'] = SimProfile
    globals()['TagSet'] = TagSet


class Sim(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('expiry_action',): {
            'None': None,
            'DONOTHING': "doNothing",
            'DELETESESSION': "deleteSession",
            'DEACTIVATE': "deactivate",
            'SUSPEND': "suspend",
            'TERMINATE': "terminate",
        },
        ('type',): {
            'EUICC': "euicc",
            'UICC': "uicc",
            'VIRTUAL': "virtual",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'active_profile_id': (str,),  # noqa: E501
            'arc_session_status': (ArcSessionStatus,),  # noqa: E501
            'capabilities': (Capabilities,),  # noqa: E501
            'created_time': (int,),  # noqa: E501
            'expiry_action': (str, none_type,),  # noqa: E501
            'expiry_time': (int, none_type,),  # noqa: E501
            'group_id': (str, none_type,),  # noqa: E501
            'imei_lock': (ImeiLock,),  # noqa: E501
            'last_modified_time': (int,),  # noqa: E501
            'last_port_mapping_created_time': (int, none_type,),  # noqa: E501
            'local_info': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'module_type': (str,),  # noqa: E501
            'operator_id': (str,),  # noqa: E501
            'ota_serial_number': (str,),  # noqa: E501
            'pcap_end_time': (int, none_type,),  # noqa: E501
            'pcap_start_time': (int, none_type,),  # noqa: E501
            'previous_session': (PreviousSessionStatus,),  # noqa: E501
            'profiles': ({str: (SimProfile,)},),  # noqa: E501
            'serial_number': (str, none_type,),  # noqa: E501
            'session_status': (SessionStatus,),  # noqa: E501
            'sim_id': (str,),  # noqa: E501
            'speed_class': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'tags': (TagSet,),  # noqa: E501
            'termination_enabled': (bool,),  # noqa: E501
            'type': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'active_profile_id': 'activeProfileId',  # noqa: E501
        'arc_session_status': 'arcSessionStatus',  # noqa: E501
        'capabilities': 'capabilities',  # noqa: E501
        'created_time': 'createdTime',  # noqa: E501
        'expiry_action': 'expiryAction',  # noqa: E501
        'expiry_time': 'expiryTime',  # noqa: E501
        'group_id': 'groupId',  # noqa: E501
        'imei_lock': 'imeiLock',  # noqa: E501
        'last_modified_time': 'lastModifiedTime',  # noqa: E501
        'last_port_mapping_created_time': 'lastPortMappingCreatedTime',  # noqa: E501
        'local_info': 'localInfo',  # noqa: E501
        'module_type': 'moduleType',  # noqa: E501
        'operator_id': 'operatorId',  # noqa: E501
        'ota_serial_number': 'otaSerialNumber',  # noqa: E501
        'pcap_end_time': 'pcapEndTime',  # noqa: E501
        'pcap_start_time': 'pcapStartTime',  # noqa: E501
        'previous_session': 'previousSession',  # noqa: E501
        'profiles': 'profiles',  # noqa: E501
        'serial_number': 'serialNumber',  # noqa: E501
        'session_status': 'sessionStatus',  # noqa: E501
        'sim_id': 'simId',  # noqa: E501
        'speed_class': 'speedClass',  # noqa: E501
        'status': 'status',  # noqa: E501
        'tags': 'tags',  # noqa: E501
        'termination_enabled': 'terminationEnabled',  # noqa: E501
        'type': 'type',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """Sim - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            active_profile_id (str): [optional]  # noqa: E501
            arc_session_status (ArcSessionStatus): [optional]  # noqa: E501
            capabilities (Capabilities): [optional]  # noqa: E501
            created_time (int): [optional]  # noqa: E501
            expiry_action (str, none_type): [optional]  # noqa: E501
            expiry_time (int, none_type): [optional]  # noqa: E501
            group_id (str, none_type): [optional]  # noqa: E501
            imei_lock (ImeiLock): [optional]  # noqa: E501
            last_modified_time (int): [optional]  # noqa: E501
            last_port_mapping_created_time (int, none_type): [optional]  # noqa: E501
            local_info ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            module_type (str): [optional]  # noqa: E501
            operator_id (str): [optional]  # noqa: E501
            ota_serial_number (str): [optional]  # noqa: E501
            pcap_end_time (int, none_type): [optional]  # noqa: E501
            pcap_start_time (int, none_type): [optional]  # noqa: E501
            previous_session (PreviousSessionStatus): [optional]  # noqa: E501
            profiles ({str: (SimProfile,)}): [optional]  # noqa: E501
            serial_number (str, none_type): [optional]  # noqa: E501
            session_status (SessionStatus): [optional]  # noqa: E501
            sim_id (str): [optional]  # noqa: E501
            speed_class (str): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            tags (TagSet): [optional]  # noqa: E501
            termination_enabled (bool): [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """Sim - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            active_profile_id (str): [optional]  # noqa: E501
            arc_session_status (ArcSessionStatus): [optional]  # noqa: E501
            capabilities (Capabilities): [optional]  # noqa: E501
            created_time (int): [optional]  # noqa: E501
            expiry_action (str, none_type): [optional]  # noqa: E501
            expiry_time (int, none_type): [optional]  # noqa: E501
            group_id (str, none_type): [optional]  # noqa: E501
            imei_lock (ImeiLock): [optional]  # noqa: E501
            last_modified_time (int): [optional]  # noqa: E501
            last_port_mapping_created_time (int, none_type): [optional]  # noqa: E501
            local_info ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            module_type (str): [optional]  # noqa: E501
            operator_id (str): [optional]  # noqa: E501
            ota_serial_number (str): [optional]  # noqa: E501
            pcap_end_time (int, none_type): [optional]  # noqa: E501
            pcap_start_time (int, none_type): [optional]  # noqa: E501
            previous_session (PreviousSessionStatus): [optional]  # noqa: E501
            profiles ({str: (SimProfile,)}): [optional]  # noqa: E501
            serial_number (str, none_type): [optional]  # noqa: E501
            session_status (SessionStatus): [optional]  # noqa: E501
            sim_id (str): [optional]  # noqa: E501
            speed_class (str): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            tags (TagSet): [optional]  # noqa: E501
            termination_enabled (bool): [optional]  # noqa: E501
            type (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
